//$Id: mod_usemap.php,v 1.5 2005/09/13 14:38:11 bjoern_heuser Exp $
//$Header: /cvsroot/mapbender/mapbender/http/javascripts/mod_usemap.php,v 1.5 2005/09/13 14:38:11 bjoern_heuser Exp $
var mod_usemap_target = 'mapframe1';
var mod_usemap_wfs = "http://localhost/cgi-bin/mapserv.exe?map=c:/ms4w/Apache/htdocs/germany/city.map&VERSION=1.0.0&REQUEST=GetFeature&SERVICE=WFS&TYPENAME=staedtepunkte";
var mod_usemap_px = 10;
var um_title;
var um_draw;

mb_registerSubFunctions('mod_usemap_init()');
mb_registerInitFunctions("um_init()")

function mod_usemap_init(){
	var ind = getMapObjIndexByName(mod_usemap_target);
	var extent = mb_mapObj[ind].extent;
  var scale  = parent.mb_getScale('mapframe1');
  if (scale < 1000000) {

	var url = "../php/mod_usemap.php?url="
	url += escape(mod_usemap_wfs + "&BBOX=" + extent);
	url += "&extent=" + extent;
	url += "&width=" + mb_mapObj[ind].width;
	url += "&height=" + mb_mapObj[ind].height;
	document.getElementById('usemap').src = url;
	var myImg = window.frames[mod_usemap_target].document.getElementById("um_img").style; 
	myImg.width = mb_mapObj[ind].width;
	myImg.height = mb_mapObj[ind].height;
  }
  else {
	var url = "../php/mod_usemap.php?url="
	url += escape("&BBOX=1,1,1,1");
	url += "&extent=1,1,1,1";
	url += "&width=" + mb_mapObj[ind].width;
	url += "&height=" + mb_mapObj[ind].height;
	document.getElementById('usemap').src = url;
	var myImg = window.frames[mod_usemap_target].document.getElementById("um_img").style; 
	myImg.width = mb_mapObj[ind].width;
	myImg.height = mb_mapObj[ind].height;
  }
}
function mod_usemap_set(title,x,y){
	var str = "";
	for(var i=0; i<title.length; i++){
		var pos = makeRealWorld2mapPos(mod_usemap_target,x[i],y[i]);
		str += "<AREA  onmouseover='parent.over(event, \"" + title[i] + "\", this)' ";
		str += "onmouseout=parent.out(this) shape='circle'  coords='";
		str += Math.round(pos[0]) + "," + Math.round(pos[1]) + "," + mod_usemap_px + "'";
		str += " href='#'>";
	}	
	writeTag(mod_usemap_target, 'um', str);
}



/* Opacity for hilighting */
    cw_opacity = 0.5;
/* Color for polygon boundary */
    cw_bndcolor = "#ff0000";
/* Color for polygon fill */
    cw_fillcolor = "#ffff00";




function polyXcoords(coords) {
    var Xcoords = '';
    for (var z = 0; z<coords.length; z=z+2) {
        if (z > 0) { Xcoords += ', '; }
            Xcoords += parseInt(coords[z]);
        }
        return Xcoords;
    }

function polyYcoords(coords) {
   var Ycoords = '';
   for (var z = 1; z<coords.length; z=z+2) {
       if (z > 1) { Ycoords += ', '; }
            Ycoords += parseInt(coords[z]);
        }
        return Ycoords;
}

function setFocus(objid) {
    if (canvasHasDrawing == true) return true;
        var coords = objid.coords.split(',');
        if ((objid.shape.toUpperCase() == 'POLY') || (objid.shape.toUpperCase() == 'POLYGON')) {
            var Xcoords = polyXcoords(coords);
            var Ycoords = polyYcoords(coords);
            var pgx = Xcoords.split(',');
            var pgy = Ycoords.split(',');
            for (var i=0 ; i<pgx.length ; i++ ) {
                pgx[i] = parseInt(pgx[i]);
                pgy[i] = parseInt(pgy[i]);
            }
            canvas.setColor(cw_fillcolor);
            canvas.fillPolygon(pgx,pgy);
            canvas.paint();
            canvas.setColor(cw_bndcolor);
            canvas.drawPolygon(pgx,pgy);
            canvas.paint();
        }
        if ((objid.shape.toUpperCase() == 'CIRCLE')) {
            var c = coords;
            canvas.setColor(cw_fillcolor);
            canvas.fillEllipse(parseInt(c[0])-mod_usemap_px/2,parseInt(c[1])-mod_usemap_px/2,parseInt(c[2]),parseInt(c[2]));
            canvas.paint();
            canvas.setColor(cw_bndcolor);
            canvas.drawEllipse(parseInt(c[0])-mod_usemap_px/2,parseInt(c[1])-mod_usemap_px/2,parseInt(c[2]),parseInt(c[2]));
            canvas.paint();            
        }
        canvasHasDrawing = true; 
        return true;
    }

function clearFocus(objid) {
    if (canvasHasDrawing) canvas.clear();
        canvasHasDrawing = false;
        return true;
    }

function over(e, id, area) {
	var coords = area.coords.split(',');
    area.setAttribute('title', "");
    if (!isOver) {
        um_title.innerHTML = id;
        um_title.style.display = "block";
        isOver = area;
        setFocus(area);
    }
    mb_arrangeElement(mod_usemap_target, 'um_title', parseInt(coords[0])+mod_usemap_px, parseInt(coords[1])+mod_usemap_px);
    canvasHasDrawing = true;
}

function out(area) {
    um_title.innerHTML = "";
    um_title.style.display = "none";
    clearFocus(area);
    isOver = false;
    canvasHasDrawing = false;
}

function um_init() {
	um_title = window.frames[mod_usemap_target].document.getElementById("um_title"); /* tooltip */
	um_draw = window.frames[mod_usemap_target].document.getElementById("um_draw"); /* tooltip */
    canvas = new jsGraphics('um_draw', window.frames['mapframe1']);
    canvas.setStroke(2);
    canvasHasDrawing = false;
    isOver = false;}
